<?php
function aws_signed_request($countryId, $params, $AWSAccessKeyId, $SecretAccessKey)
{
/*
 6.    Copyright (c) 2009 Ulrich Mierendorff
 7. 
 8.    Permission is hereby granted, free of charge, to any person obtaining a
 9.    copy of this software and associated documentation files (the "Software"),
 10.    to deal in the Software without restriction, including without limitation
 11.    the rights to use, copy, modify, merge, publish, distribute, sublicense,
 12.    and/or sell copies of the Software, and to permit persons to whom the
 13.    Software is furnished to do so, subject to the following conditions:
 14. 
 15.    The above copyright notice and this permission notice shall be included in
 16.    all copies or substantial portions of the Software.
 17. 
 18.    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 19.    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 20.    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 21.    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 22.    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 23.    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 24.    DEALINGS IN THE SOFTWARE.
 25.    */

/*
 28.    Parameters:
 29.        $region - the Amazon(r) region (ca,com,co.uk,de,fr,jp)
 30.        $params - an array of parameters, eg. array("Operation"=>"ItemLookup",
 31.                        "ItemId"=>"B000X9FLKM", "ResponseGroup"=>"Small")
 32.        $public_key - your "Access Key ID"
 33.        $private_key - your "Secret Access Key"
 34.    */

// some paramters
$method = "GET";
$host = 'webservices.amazon.'.$countryId;
$uri = "/onca/xml";
// additional parameters
$params["Service"] = "AWSECommerceService";
$params["AWSAccessKeyId"] = $AWSAccessKeyId;
// GMT timestamp
$params["Timestamp"] = gmdate("Y-m-d\TH:i:s\Z");
// API version
$params["Version"] = "2011-08-01"; 

// sort the parameters
ksort($params);

 // create the canonicalized query
$canonicalized_query = array();
foreach ($params as $param=>$value)
{
$param = str_replace("%7E", "~", rawurlencode($param));
$value = str_replace("%7E", "~", rawurlencode($value));
$canonicalized_query[] = $param."=".$value;
}
$canonicalized_query = implode("&", $canonicalized_query);

// create the string to sign
$string_to_sign = $method."\n".$host."\n".$uri."\n".$canonicalized_query;

 // calculate HMAC with SHA256 and base64-encoding
$signature = base64_encode(hash_hmac("sha256", $string_to_sign, $SecretAccessKey, True));

 // encode the signature for the request
$signature = str_replace("%7E", "~", rawurlencode($signature));

// create request
$request = "http://".$host.$uri."?".$canonicalized_query."&Signature=".$signature;

// request
   // $signed_request = "http://".$host.$uri."?".$canonicalized_query."&Signature=".$signature;



// do request
$response = @file_get_contents($request);

if ($response === False)
{
       return False;
}
else
{
// parse XML
 //$pxml = simplexml_load_string($response);
 $xml = simplexml_load_string($response);
if ($xml === False)
{
 return False; // no xml
}
 else
{
return $xml;
}
}
}
?>